/* Copyright (c) 2002 - 2004 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor klavesnice.c */

#include <unistd.h>
#include <stdlib.h>
/* #include <curses.h> */
#include <errno.h>
#include "profi/klavesnice-c-include.h"
#include "strukturyw.h"
#include "box3.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "barvy.h"

static void tiskni_klavesnici (WINDOW * win, int lines, int cols, char ch);

void
klavesnice (void)
{
  WINDOW *new_zprava;
  int ch;
  static boolean spusteno;

  if (spusteno)
    return;
  spusteno = 1;

  if ((new_zprava = newwin2 (14, 70, (LINES - 14) / 2, (COLS - 70) / 2))
      == NULL)
    {
      print_hl (1, "CHYBA: Nelze zobrazit klavesnici!");
      if (global_get (g_warning) == g_w_ano)
	perror ("klavesnice()");
      return;
    }

  pridej_do_priority_w (1, new_zprava, stdscr, LINES - 1, 0);
  tiskni_klavesnici (new_zprava, 14, 70, '\n');
  tiskni_dle_priority ();
#include "profi/klavesnice-c-halfdelay.h"
  do
    {
      ch = getch3 ();
      if (ch == '\0')
	{
	  tiskni_klavesnici (new_zprava, 14, 70, '\n');
	  tiskni_dle_priority ();
	  continue;
	}
#include "profi/klavesnice-c-tiskni.h"
    }
  while ((ch != '\n') && (ch != KEY_BACKSPACE));
#include "profi/klavesnice-c-halfdelay0.h"

  odeber_z_priority (new_zprava);
  delwin2 (new_zprava);
  spusteno = 0;

  tiskni_dle_priority ();
}

static void
tiskni_klavesnici (WINDOW * win, int lines, int cols, char ch)
{
#define POSUNKL 5
  int i, j;
  char pom[3];
  char *kl1[] =
    { " ___ ___ ___ ___ ___ ___ ___ ___ ___ ___ ___ ___ ___ ______",
    "|`; |1+ |2 |3 |4 |5 |6 | 7| 8| 9| 0| =%| '|<-BACK|",
    "`---^---^---^---^---^---^---^---^---^---^---^---^---'------'",
    "| TAB |q  |w  |e  |r  |t  |  z|  u|  i|  o|  p| /| )(|    |",
    "`---- `---^---^---^---^---^---^---^---^---^---^---^---'    |",
    "| CAPS |a  |s  |d  |f_ |g  |  h| _j|  k|  l| \"| !| ENTER |",
    "`----- `---^---^---^---^---^---^---^---^---^---^---^-------'",
    "| SHIFT  |  y|x  |c  |v  |b  |  n|  m| ,?| .:| -_| SHIFT |",
    "`--------^---^---^---^---^---^---^---^---^---^---^-------'"
  };

  char *klz[] = { " `;  1+  2  3  4  5  6   7  8  9  0  =%  '",
    "       q   w   e   r   t     z   u   i   o   p  /  )(",
    "        a   s   d   f   g     h   j   k   l  \"  !",
    "            y x   c   v   b     n   m  ,?  .:  -_"
  };
  char *kly[] = { " `;  1+  2  3  4  5  6   7  8  9  0  =%  '",
    "       q   w   e   r   t     y   u   i   o   p  /  )(",
    "        a   s   d   f   g     h   j   k   l  \"  !",
    "            z x   c   v   b     n   m  ,?  .:  -_"
  };
  char *mezernik = "|_______mezernik________|";
  char **kl2 = kly;

  if (global_get (g_qwertz) == g_q_z)
    kl2 = klz;

  wattron2 (win, COLOR_PAIR (COLOR_KLAVESNICE_HLAVNI));
  /* smazani celeho okna kvuli pruhlednemu terminalu */
  for (i = 0; i < lines; i++)
    for (j = 0; j < cols; j++)
      mvwaddch2 (win, i, j, ' ');
  wattron2 (win, A_BOLD);

  for (i = 0; i < sizeof (kl1) / sizeof (char *); i++)
    mvwprintw2 (win, i + 1, POSUNKL, kl1[i]);

  for (j = 0; j < sizeof (kly) / sizeof (char *); j++)
    {
      i = -1;
      while (kl2[j][++i])
	{
	  if (kl2[j][i] == ' ')
	    continue;

	  pom[0] = kl2[j][i];
	  pom[1] = kl2[j][i];
	  pom[2] = '\0';

#include "profi/klavesnice-c-keys.h"

	  wattron2 (win, A_BOLD);
	  switch (pom[1])
	    {
	    case 'p':
	    case '"':
	    case '':
	    case '/':
	    case '':
	    case '!':
	    case '':
	    case ')':
	    case '(':
	    case '=':
	    case '%':
	    case '\'':
	    case '':
	    case '-':
	    case '_':
	      wattroff2 (win, A_BOLD);
	    case '1':
	    case '2':
	    case ';':
	    case '+':
	    case 'q':
	    case 'a':
	    case '':
	    case '`':
	      wattron2 (win, COLOR_PAIR (COLOR_KLAVESNICE_MALICEK));
	      break;
	    case '5':
	    case '':
	    case '':
	    case '6':
	    case 'r':
	    case 't':
	    case 'f':
	    case 'g':
	    case 'b':
	    case 'v':
	      wattroff2 (win, A_BOLD);
	    case 'n':
	    case 'j':
	    case 'm':
	    case 'u':
	    case 'h':
	    case '':
	    case '7':
	    case '8':
	    case '':
	      wattron2 (win, COLOR_PAIR (COLOR_KLAVESNICE_UKAZOVACEK));
	      break;
	    case '':
	    case '3':
	    case 'w':
	    case 's':
	    case 'x':
	      wattroff2 (win, A_BOLD);
	    case '0':
	    case '':
	    case 'o':
	    case 'l':
	    case ':':
	    case '.':
	      wattron2 (win, COLOR_PAIR (COLOR_KLAVESNICE_PRSTENICEK));
	      break;
	    case '':
	    case '9':
	    case 'i':
	    case 'k':
	    case ',':
	    case '?':
	      wattroff2 (win, A_BOLD);
	    case '4':
	    case '':
	    case 'e':
	    case 'd':
	    case 'c':
	      wattron2 (win, COLOR_PAIR (COLOR_KLAVESNICE_PROSTREDNICEK));
	      break;
	    case 'y':
	      if (global_get (g_qwertz) == g_q_z)
		wattron2 (win, COLOR_PAIR (COLOR_KLAVESNICE_MALICEK));
	      else
		wattron2 (win, COLOR_PAIR (COLOR_KLAVESNICE_UKAZOVACEK));
	      break;
	    case 'z':
	      if (global_get (g_qwertz) == g_q_z)
		wattron2 (win, COLOR_PAIR (COLOR_KLAVESNICE_UKAZOVACEK));
	      else
		wattron2 (win, COLOR_PAIR (COLOR_KLAVESNICE_MALICEK));
	      break;
	    }			/* switch */

	  MVWPRINTW2 (win, 2 * (j + 1), POSUNKL + i, "%c", pom[0]);
	  wattroff2 (win, A_REVERSE);
	}			/* while */
    }
#include "profi/klavesnice-c-reverse.h"
  wattron2 (win, COLOR_PAIR (COLOR_KLAVESNICE_HLAVNI) | A_BOLD);
  mvwprintw2 (win, 10, POSUNKL + 16, mezernik);
#include "profi/klavesnice-c-reverse0.h"

  mvwprintw2 (win, 12, 30, "< OK >");
  box3 (win, '|', '-');
}
