/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor znamky.c */

#include "struktury.h"
#include "lib.h"

type_znamka
znamka_lekce (type_informace infolekce, unsigned int oznaku,
	      unsigned int CHYB, unsigned int VTERIN)
{
  return znamka_z (infolekce.presnost, infolekce.rychlost, oznaku, CHYB,
		   VTERIN);
}

/*-----------------------------------------------------------------------*/
type_znamka
znamka_nov_lekce (type_vtext vtext, unsigned int oznaku,
		  unsigned int CHYB, unsigned int VTERIN)
{
  return znamka_z (vtext.presnost, vtext.rychlost, oznaku, CHYB, VTERIN);
}

/*-----------------------------------------------------------------------*/
type_znamka
znamka_z (unsigned int presnost[5], unsigned int rychlost[5],
	  unsigned int oznaku, unsigned int CHYB, unsigned int VTERIN)
{
  type_znamka z;
  unsigned int pom, i;

  z.vterin = VTERIN;
  z.chyb = CHYB;

  if (10 * CHYB < oznaku)
    z.cznak = oznaku - 10 * CHYB;
  else
    z.cznak = 0;

  z.proc_chyb = (float) CHYB / oznaku * 100.0;
  z.uh_min = (int) ((float) z.cznak / VTERIN * 60.0);

  z.znamka_presnost = 5.0;
  z.znamka_cas = 5.0;

  pom = (int) ((float) z.proc_chyb * 100.0);

  if (pom <= presnost[0])
    {
      z.znamka_presnost = 1.0;
    }
  else if (pom >= presnost[4])
    {
      z.znamka_presnost = 5.0;
    }
  else
    for (i = 0; i <= 3; i++)
      if ((pom >= presnost[i]) && (pom <= presnost[i + 1]))
	{
	  z.znamka_presnost = presnost[i + 1] - presnost[i];
	  z.znamka_presnost = 1 / z.znamka_presnost;
	  z.znamka_presnost *= (pom - presnost[i]);
	  z.znamka_presnost = i + z.znamka_presnost + 1;
	  break;
	}

  if (z.uh_min <= rychlost[4])
    {
      z.znamka_cas = 5.0;
    }
  else if (z.uh_min >= rychlost[0])
    {
      z.znamka_cas = 1.0;
    }
  else
    for (i = 0; i <= 3; i++)
      if (z.uh_min <= rychlost[i] && z.uh_min >= rychlost[i + 1])
	{
	  z.znamka_cas = rychlost[i] - rychlost[i + 1];
	  z.znamka_cas = 1 / z.znamka_cas;
	  z.znamka_cas *= (z.uh_min - rychlost[i + 1]);
	  z.znamka_cas = i + 1 - z.znamka_cas;
	  break;
	}

  if (z.znamka_presnost > z.znamka_cas)
    z.znamka = ((z.znamka_presnost * 66 + z.znamka_cas * 34) / 100);
  else
    z.znamka = ((z.znamka_presnost * 34 + z.znamka_cas * 66) / 100);

  return z;
}
